# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from getopenpay.models.checkout_mode import CheckoutMode
from getopenpay.models.object_name import ObjectName
from getopenpay.models.payment_link_line_item_external import PaymentLinkLineItemExternal

class PaymentLinkExternal(BaseModel):
    """
    PaymentLinkExternal
    """
    id: StrictStr = Field(...)
    object: Optional[ObjectName] = None
    created_at: datetime = Field(..., description="DateTime at which the object was created, in 'ISO 8601' format.")
    updated_at: datetime = Field(..., description="DateTime at which the object was updated, in 'ISO 8601' format.")
    is_deleted: Optional[StrictBool] = Field(False, description="If true, indicates that this object has been deleted")
    account_id: StrictStr = Field(...)
    account_name: StrictStr = Field(...)
    active: StrictBool = Field(...)
    currency: Optional[StrictStr] = None
    line_items: Optional[conlist(PaymentLinkLineItemExternal)] = None
    mode: CheckoutMode = Field(...)
    secure_token: StrictStr = Field(...)
    success_url: StrictStr = Field(...)
    url: StrictStr = Field(...)
    __properties = ["id", "object", "created_at", "updated_at", "is_deleted", "account_id", "account_name", "active", "currency", "line_items", "mode", "secure_token", "success_url", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentLinkExternal:
        """Create an instance of PaymentLinkExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in line_items (list)
        _items = []
        if self.line_items:
            for _item in self.line_items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['line_items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentLinkExternal:
        """Create an instance of PaymentLinkExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentLinkExternal.parse_obj(obj)

        _obj = PaymentLinkExternal.parse_obj({
            "id": obj.get("id"),
            "object": obj.get("object"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "account_id": obj.get("account_id"),
            "account_name": obj.get("account_name"),
            "active": obj.get("active"),
            "currency": obj.get("currency"),
            "line_items": [PaymentLinkLineItemExternal.from_dict(_item) for _item in obj.get("line_items")] if obj.get("line_items") is not None else None,
            "mode": obj.get("mode"),
            "secure_token": obj.get("secure_token"),
            "success_url": obj.get("success_url"),
            "url": obj.get("url")
        })
        return _obj


